Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4671)
@@ -2950,13 +3008,15 @@
 !--    Map values to the respective 2D/3D arrays
 !--    Horizontal surfaces
-       surf_lsm_h%alpha_vg      = alpha_vangenuchten
-       surf_lsm_h%l_vg          = l_vangenuchten
-       surf_lsm_h%n_vg          = n_vangenuchten
-       surf_lsm_h%gamma_w_sat   = hydraulic_conductivity
-       surf_lsm_h%m_sat         = saturation_moisture
-       surf_lsm_h%m_fc          = field_capacity
-       surf_lsm_h%m_wilt        = wilting_point
-       surf_lsm_h%m_res         = residual_moisture
-       surf_lsm_h%r_soil_min    = min_soil_resistance
+       DO  l = 0, 1
+          surf_lsm_h(l)%alpha_vg      = alpha_vangenuchten
+          surf_lsm_h(l)%l_vg          = l_vangenuchten
+          surf_lsm_h(l)%n_vg          = n_vangenuchten
+          surf_lsm_h(l)%gamma_w_sat   = hydraulic_conductivity
+          surf_lsm_h(l)%m_sat         = saturation_moisture
+          surf_lsm_h(l)%m_fc          = field_capacity
+          surf_lsm_h(l)%m_wilt        = wilting_point
+          surf_lsm_h(l)%m_res         = residual_moisture
+          surf_lsm_h(l)%r_soil_min    = min_soil_resistance
+       ENDDO
 !
 !--    Vertical surfaces
@@ -2984,19 +3044,21 @@
 !
 !--          Horizontal surfaces
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-
-                st = soil_type_f%var_2d(j,i)
-                IF ( st /= soil_type_f%fill )  THEN
-                   surf_lsm_h%alpha_vg(:,m)    = soil_pars(0,st)
-                   surf_lsm_h%l_vg(:,m)        = soil_pars(1,st)
-                   surf_lsm_h%n_vg(:,m)        = soil_pars(2,st)
-                   surf_lsm_h%gamma_w_sat(:,m) = soil_pars(3,st)
-                   surf_lsm_h%m_sat(:,m)       = soil_pars(4,st)
-                   surf_lsm_h%m_fc(:,m)        = soil_pars(5,st)
-                   surf_lsm_h%m_wilt(:,m)      = soil_pars(6,st)
-                   surf_lsm_h%m_res(:,m)       = soil_pars(7,st)
-                ENDIF
+             DO  l = 0, 1
+                DO  m = 1, surf_lsm_h(l)%ns
+                   i = surf_lsm_h(l)%i(m)
+                   j = surf_lsm_h(l)%j(m)
+
+                   st = soil_type_f%var_2d(j,i)
+                   IF ( st /= soil_type_f%fill )  THEN
+                      surf_lsm_h(l)%alpha_vg(:,m)    = soil_pars(0,st)
+                      surf_lsm_h(l)%l_vg(:,m)        = soil_pars(1,st)
+                      surf_lsm_h(l)%n_vg(:,m)        = soil_pars(2,st)
+                      surf_lsm_h(l)%gamma_w_sat(:,m) = soil_pars(3,st)
+                      surf_lsm_h(l)%m_sat(:,m)       = soil_pars(4,st)
+                      surf_lsm_h(l)%m_fc(:,m)        = soil_pars(5,st)
+                      surf_lsm_h(l)%m_wilt(:,m)      = soil_pars(6,st)
+                      surf_lsm_h(l)%m_res(:,m)       = soil_pars(7,st)
+                   ENDIF
+                ENDDO
              ENDDO
 !
@@ -3028,20 +3090,22 @@
 !
 !--          Horizontal surfaces
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-
-                DO  k = nzb_soil, nzt_soil
-                   st = soil_type_f%var_3d(k,j,i)
-                   IF ( st /= soil_type_f%fill )  THEN
-                      surf_lsm_h%alpha_vg(k,m)    = soil_pars(0,st)
-                      surf_lsm_h%l_vg(k,m)        = soil_pars(1,st)
-                      surf_lsm_h%n_vg(k,m)        = soil_pars(2,st)
-                      surf_lsm_h%gamma_w_sat(k,m) = soil_pars(3,st)
-                      surf_lsm_h%m_sat(k,m)       = soil_pars(4,st)
-                      surf_lsm_h%m_fc(k,m)        = soil_pars(5,st)
-                      surf_lsm_h%m_wilt(k,m)      = soil_pars(6,st)
-                      surf_lsm_h%m_res(k,m)       = soil_pars(7,st)
-                   ENDIF
+             DO  l = 0, 1
+                DO  m = 1, surf_lsm_h(l)%ns
+                   i = surf_lsm_h(l)%i(m)
+                   j = surf_lsm_h(l)%j(m)
+
+                   DO  k = nzb_soil, nzt_soil
+                      st = soil_type_f%var_3d(k,j,i)
+                      IF ( st /= soil_type_f%fill )  THEN
+                         surf_lsm_h(l)%alpha_vg(k,m)    = soil_pars(0,st)
+                         surf_lsm_h(l)%l_vg(k,m)        = soil_pars(1,st)
+                         surf_lsm_h(l)%n_vg(k,m)        = soil_pars(2,st)
+                         surf_lsm_h(l)%gamma_w_sat(k,m) = soil_pars(3,st)
+                         surf_lsm_h(l)%m_sat(k,m)       = soil_pars(4,st)
+                         surf_lsm_h(l)%m_fc(k,m)        = soil_pars(5,st)
+                         surf_lsm_h(l)%m_wilt(k,m)      = soil_pars(6,st)
+                         surf_lsm_h(l)%m_res(k,m)       = soil_pars(7,st)
+                      ENDIF
+                   ENDDO
                 ENDDO
              ENDDO
@@ -3083,25 +3147,26 @@
 !
 !--          Horizontal surfaces
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-
-                IF ( soil_pars_f%pars_xy(0,j,i) /= soil_pars_f%fill )              &
-                   surf_lsm_h%alpha_vg(:,m)    = soil_pars_f%pars_xy(0,j,i)
-                IF ( soil_pars_f%pars_xy(1,j,i) /= soil_pars_f%fill )              &
-                   surf_lsm_h%l_vg(:,m)        = soil_pars_f%pars_xy(1,j,i)
-                IF ( soil_pars_f%pars_xy(2,j,i) /= soil_pars_f%fill )              &
-                   surf_lsm_h%n_vg(:,m)        = soil_pars_f%pars_xy(2,j,i)
-                IF ( soil_pars_f%pars_xy(3,j,i) /= soil_pars_f%fill )              &
-                   surf_lsm_h%gamma_w_sat(:,m) = soil_pars_f%pars_xy(3,j,i)
-                IF ( soil_pars_f%pars_xy(4,j,i) /= soil_pars_f%fill )              &
-                   surf_lsm_h%m_sat(:,m)       = soil_pars_f%pars_xy(4,j,i)
-                IF ( soil_pars_f%pars_xy(5,j,i) /= soil_pars_f%fill )              &
-                   surf_lsm_h%m_fc(:,m)        = soil_pars_f%pars_xy(5,j,i)
-                IF ( soil_pars_f%pars_xy(6,j,i) /= soil_pars_f%fill )              &
-                   surf_lsm_h%m_wilt(:,m)      = soil_pars_f%pars_xy(6,j,i)
-                IF ( soil_pars_f%pars_xy(7,j,i) /= soil_pars_f%fill )              &
-                   surf_lsm_h%m_res(:,m)       = soil_pars_f%pars_xy(7,j,i)
-
+             DO  l = 0, 1
+                DO  m = 1, surf_lsm_h(l)%ns
+                   i = surf_lsm_h(l)%i(m)
+                   j = surf_lsm_h(l)%j(m)
+
+                   IF ( soil_pars_f%pars_xy(0,j,i) /= soil_pars_f%fill )              &
+                      surf_lsm_h(l)%alpha_vg(:,m)    = soil_pars_f%pars_xy(0,j,i)
+                   IF ( soil_pars_f%pars_xy(1,j,i) /= soil_pars_f%fill )              &
+                      surf_lsm_h(l)%l_vg(:,m)        = soil_pars_f%pars_xy(1,j,i)
+                   IF ( soil_pars_f%pars_xy(2,j,i) /= soil_pars_f%fill )              &
+                      surf_lsm_h(l)%n_vg(:,m)        = soil_pars_f%pars_xy(2,j,i)
+                   IF ( soil_pars_f%pars_xy(3,j,i) /= soil_pars_f%fill )              &
+                      surf_lsm_h(l)%gamma_w_sat(:,m) = soil_pars_f%pars_xy(3,j,i)
+                   IF ( soil_pars_f%pars_xy(4,j,i) /= soil_pars_f%fill )              &
+                      surf_lsm_h(l)%m_sat(:,m)       = soil_pars_f%pars_xy(4,j,i)
+                   IF ( soil_pars_f%pars_xy(5,j,i) /= soil_pars_f%fill )              &
+                      surf_lsm_h(l)%m_fc(:,m)        = soil_pars_f%pars_xy(5,j,i)
+                   IF ( soil_pars_f%pars_xy(6,j,i) /= soil_pars_f%fill )              &
+                      surf_lsm_h(l)%m_wilt(:,m)      = soil_pars_f%pars_xy(6,j,i)
+                   IF ( soil_pars_f%pars_xy(7,j,i) /= soil_pars_f%fill )              &
+                      surf_lsm_h(l)%m_res(:,m)       = soil_pars_f%pars_xy(7,j,i)
+                ENDDO
              ENDDO
 !
@@ -3139,27 +3204,28 @@
 !
 !--          Horizontal surfaces
-             DO  m = 1, surf_lsm_h%ns
-                i = surf_lsm_h%i(m)
-                j = surf_lsm_h%j(m)
-
-                DO  k = nzb_soil, nzt_soil
-                   IF ( soil_pars_f%pars_xyz(0,k,j,i) /= soil_pars_f%fill )        &
-                      surf_lsm_h%alpha_vg(k,m)    = soil_pars_f%pars_xyz(0,k,j,i)
-                   IF ( soil_pars_f%pars_xyz(1,k,j,i) /= soil_pars_f%fill )        &
-                      surf_lsm_h%l_vg(k,m)        = soil_pars_f%pars_xyz(1,k,j,i)
-                   IF ( soil_pars_f%pars_xyz(2,k,j,i) /= soil_pars_f%fill )        &
-                      surf_lsm_h%n_vg(k,m)        = soil_pars_f%pars_xyz(2,k,j,i)
-                   IF ( soil_pars_f%pars_xyz(3,k,j,i) /= soil_pars_f%fill )        &
-                      surf_lsm_h%gamma_w_sat(k,m) = soil_pars_f%pars_xyz(3,k,j,i)
-                   IF ( soil_pars_f%pars_xyz(4,k,j,i) /= soil_pars_f%fill )        &
-                      surf_lsm_h%m_sat(k,m)       = soil_pars_f%pars_xyz(4,k,j,i)
-                   IF ( soil_pars_f%pars_xyz(5,k,j,i) /= soil_pars_f%fill )        &
-                      surf_lsm_h%m_fc(k,m)        = soil_pars_f%pars_xyz(5,k,j,i)
-                   IF ( soil_pars_f%pars_xyz(6,k,j,i) /= soil_pars_f%fill )        &
-                      surf_lsm_h%m_wilt(k,m)      = soil_pars_f%pars_xyz(6,k,j,i)
-                   IF ( soil_pars_f%pars_xyz(7,k,j,i) /= soil_pars_f%fill )        &
-                      surf_lsm_h%m_res(k,m)       = soil_pars_f%pars_xyz(7,k,j,i)
+             DO  l = 0, 1
+                DO  m = 1, surf_lsm_h(l)%ns
+                   i = surf_lsm_h(l)%i(m)
+                   j = surf_lsm_h(l)%j(m)
+
+                   DO  k = nzb_soil, nzt_soil
+                      IF ( soil_pars_f%pars_xyz(0,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_h(l)%alpha_vg(k,m)    = soil_pars_f%pars_xyz(0,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(1,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_h(l)%l_vg(k,m)        = soil_pars_f%pars_xyz(1,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(2,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_h(l)%n_vg(k,m)        = soil_pars_f%pars_xyz(2,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(3,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_h(l)%gamma_w_sat(k,m) = soil_pars_f%pars_xyz(3,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(4,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_h(l)%m_sat(k,m)       = soil_pars_f%pars_xyz(4,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(5,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_h(l)%m_fc(k,m)        = soil_pars_f%pars_xyz(5,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(6,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_h(l)%m_wilt(k,m)      = soil_pars_f%pars_xyz(6,k,j,i)
+                      IF ( soil_pars_f%pars_xyz(7,k,j,i) /= soil_pars_f%fill )        &
+                         surf_lsm_h(l)%m_res(k,m)       = soil_pars_f%pars_xyz(7,k,j,i)
+                   ENDDO
                 ENDDO
-
              ENDDO
 !
@@ -3257,28 +3323,29 @@
 !
 !--    Map values onto horizontal elemements
-       DO  m = 1, surf_lsm_h%ns
-          IF ( surf_lsm_h%vegetation_surface(m) )  THEN
-             surf_lsm_h%r_canopy_min(m)     = min_canopy_resistance
-             surf_lsm_h%lai(m)              = leaf_area_index
-             surf_lsm_h%c_veg(m)            = vegetation_coverage
-             surf_lsm_h%g_d(m)              = canopy_resistance_coefficient
-             surf_lsm_h%z0(m)               = z0_vegetation
-             surf_lsm_h%z0h(m)              = z0h_vegetation
-             surf_lsm_h%z0q(m)              = z0q_vegetation
-             surf_lsm_h%lambda_surface_s(m) = lambda_surface_stable
-             surf_lsm_h%lambda_surface_u(m) = lambda_surface_unstable
-             surf_lsm_h%f_sw_in(m)          = f_shortwave_incoming
-             surf_lsm_h%c_surface(m)        = c_surface
-             surf_lsm_h%albedo_type(m,ind_veg_wall) = albedo_type
-             surf_lsm_h%emissivity(m,ind_veg_wall)  = emissivity
-
-             surf_lsm_h%vegetation_type(m)      = vegetation_type
-             surf_lsm_h%vegetation_type_name(m) = vegetation_type_name(vegetation_type)
-          ELSE
-             surf_lsm_h%lai(m)   = 0.0_wp
-             surf_lsm_h%c_veg(m) = 0.0_wp
-             surf_lsm_h%g_d(m)   = 0.0_wp
-          ENDIF
-
+       DO  l = 0, 1
+          DO  m = 1, surf_lsm_h(l)%ns
+             IF ( surf_lsm_h(l)%vegetation_surface(m) )  THEN
+                surf_lsm_h(l)%r_canopy_min(m)     = min_canopy_resistance
+                surf_lsm_h(l)%lai(m)              = leaf_area_index
+                surf_lsm_h(l)%c_veg(m)            = vegetation_coverage
+                surf_lsm_h(l)%g_d(m)              = canopy_resistance_coefficient
+                surf_lsm_h(l)%z0(m)               = z0_vegetation
+                surf_lsm_h(l)%z0h(m)              = z0h_vegetation
+                surf_lsm_h(l)%z0q(m)              = z0q_vegetation
+                surf_lsm_h(l)%lambda_surface_s(m) = lambda_surface_stable
+                surf_lsm_h(l)%lambda_surface_u(m) = lambda_surface_unstable
+                surf_lsm_h(l)%f_sw_in(m)          = f_shortwave_incoming
+                surf_lsm_h(l)%c_surface(m)        = c_surface
+                surf_lsm_h(l)%albedo_type(m,ind_veg_wall) = albedo_type
+                surf_lsm_h(l)%emissivity(m,ind_veg_wall)  = emissivity
+
+                surf_lsm_h(l)%vegetation_type(m)      = vegetation_type
+                surf_lsm_h(l)%vegetation_type_name(m) = vegetation_type_name(vegetation_type)
+             ELSE
+                surf_lsm_h(l)%lai(m)   = 0.0_wp
+                surf_lsm_h(l)%c_veg(m) = 0.0_wp
+                surf_lsm_h(l)%g_d(m)   = 0.0_wp
+             ENDIF
+          ENDDO
        ENDDO
 !
@@ -3320,27 +3387,29 @@
 !
 !--       Horizontal surfaces
-          DO  m = 1, surf_lsm_h%ns
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-
-             st = vegetation_type_f%var(j,i)
-             IF ( st /= vegetation_type_f%fill  .AND.  st /= 0 )  THEN
-                surf_lsm_h%r_canopy_min(m)     = vegetation_pars(ind_v_rc_min,st)
-                surf_lsm_h%lai(m)              = vegetation_pars(ind_v_rc_lai,st)
-                surf_lsm_h%c_veg(m)            = vegetation_pars(ind_v_c_veg,st)
-                surf_lsm_h%g_d(m)              = vegetation_pars(ind_v_gd,st)
-                surf_lsm_h%z0(m)               = vegetation_pars(ind_v_z0,st)
-                surf_lsm_h%z0h(m)              = vegetation_pars(ind_v_z0qh,st)
-                surf_lsm_h%z0q(m)              = vegetation_pars(ind_v_z0qh,st)
-                surf_lsm_h%lambda_surface_s(m) = vegetation_pars(ind_v_lambda_s,st)
-                surf_lsm_h%lambda_surface_u(m) = vegetation_pars(ind_v_lambda_u,st)
-                surf_lsm_h%f_sw_in(m)          = vegetation_pars(ind_v_f_sw_in,st)
-                surf_lsm_h%c_surface(m)        = vegetation_pars(ind_v_c_surf,st)
-                surf_lsm_h%albedo_type(m,ind_veg_wall) = INT( vegetation_pars(ind_v_at,st) )
-                surf_lsm_h%emissivity(m,ind_veg_wall)  = vegetation_pars(ind_v_emis,st)
-
-                surf_lsm_h%vegetation_type(m)      = st
-                surf_lsm_h%vegetation_type_name(m) = vegetation_type_name(st)
-             ENDIF
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+
+                st = vegetation_type_f%var(j,i)
+                IF ( st /= vegetation_type_f%fill  .AND.  st /= 0 )  THEN
+                   surf_lsm_h(l)%r_canopy_min(m)     = vegetation_pars(ind_v_rc_min,st)
+                   surf_lsm_h(l)%lai(m)              = vegetation_pars(ind_v_rc_lai,st)
+                   surf_lsm_h(l)%c_veg(m)            = vegetation_pars(ind_v_c_veg,st)
+                   surf_lsm_h(l)%g_d(m)              = vegetation_pars(ind_v_gd,st)
+                   surf_lsm_h(l)%z0(m)               = vegetation_pars(ind_v_z0,st)
+                   surf_lsm_h(l)%z0h(m)              = vegetation_pars(ind_v_z0qh,st)
+                   surf_lsm_h(l)%z0q(m)              = vegetation_pars(ind_v_z0qh,st)
+                   surf_lsm_h(l)%lambda_surface_s(m) = vegetation_pars(ind_v_lambda_s,st)
+                   surf_lsm_h(l)%lambda_surface_u(m) = vegetation_pars(ind_v_lambda_u,st)
+                   surf_lsm_h(l)%f_sw_in(m)          = vegetation_pars(ind_v_f_sw_in,st)
+                   surf_lsm_h(l)%c_surface(m)        = vegetation_pars(ind_v_c_surf,st)
+                   surf_lsm_h(l)%albedo_type(m,ind_veg_wall) = INT( vegetation_pars(ind_v_at,st) )
+                   surf_lsm_h(l)%emissivity(m,ind_veg_wall)  = vegetation_pars(ind_v_emis,st)
+
+                   surf_lsm_h(l)%vegetation_type(m)      = st
+                   surf_lsm_h(l)%vegetation_type_name(m) = vegetation_type_name(st)
+                ENDIF
+             ENDDO
           ENDDO
 !
@@ -3381,75 +3450,76 @@
 !
 !--       Horizontal surfaces
-          DO  m = 1, surf_lsm_h%ns
-
-             i = surf_lsm_h%i(m)
-             j = surf_lsm_h%j(m)
-!
-!--          If surface element is not a vegetation surface and any value in
-!--          vegetation_pars is given, neglect this information and give an
-!--          informative message that this value will not be used.
-             IF ( .NOT. surf_lsm_h%vegetation_surface(m)  .AND.                &
-                   ANY( vegetation_pars_f%pars_xy(:,j,i) /=                    &
-                   vegetation_pars_f%fill ) )  THEN
-                WRITE( message_string, * )                                     &
-                                 'surface element at grid point (j,i) = (',    &
-                                 j, i, ') is not a vegetation surface, ',      &
-                                 'so that information given in ',              &
-                                 'vegetation_pars at this point is neglected.'
-                CALL message( 'land_surface_model_mod', 'PA0436', 0, 0, myid, 6, 0 )
-             ELSE
-
-                IF ( vegetation_pars_f%pars_xy(ind_v_rc_min,j,i) /=            &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%r_canopy_min(m)  =                               &
-                                   vegetation_pars_f%pars_xy(ind_v_rc_min,j,i)
-                IF ( vegetation_pars_f%pars_xy(ind_v_rc_lai,j,i) /=            &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%lai(m)           =                               &
-                                   vegetation_pars_f%pars_xy(ind_v_rc_lai,j,i)
-                IF ( vegetation_pars_f%pars_xy(ind_v_c_veg,j,i) /=             &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%c_veg(m)         =                               &
-                                   vegetation_pars_f%pars_xy(ind_v_c_veg,j,i)
-                IF ( vegetation_pars_f%pars_xy(ind_v_gd,j,i) /=                &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%g_d(m)           =                               &
-                                   vegetation_pars_f%pars_xy(ind_v_gd,j,i)
-                IF ( vegetation_pars_f%pars_xy(ind_v_z0,j,i) /=                &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%z0(m)            =                               &
-                                   vegetation_pars_f%pars_xy(ind_v_z0,j,i)
-                IF ( vegetation_pars_f%pars_xy(ind_v_z0qh,j,i) /=              &
-                     vegetation_pars_f%fill )  THEN
-                   surf_lsm_h%z0h(m)           =                               &
-                                   vegetation_pars_f%pars_xy(ind_v_z0qh,j,i)
-                   surf_lsm_h%z0q(m)           =                               &
-                                   vegetation_pars_f%pars_xy(ind_v_z0qh,j,i)
+          DO  l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                i = surf_lsm_h(l)%i(m)
+                j = surf_lsm_h(l)%j(m)
+!
+!--             If surface element is not a vegetation surface and any value in
+!--             vegetation_pars is given, neglect this information and give an
+!--             informative message that this value will not be used.
+                IF ( .NOT. surf_lsm_h(l)%vegetation_surface(m)  .AND.                &
+                      ANY( vegetation_pars_f%pars_xy(:,j,i) /=                    &
+                      vegetation_pars_f%fill ) )  THEN
+                   WRITE( message_string, * )                                     &
+                                    'surface element at grid point (j,i) = (',    &
+                                    j, i, ') is not a vegetation surface, ',      &
+                                    'so that information given in ',              &
+                                    'vegetation_pars at this point is neglected.'
+                   CALL message( 'land_surface_model_mod', 'PA0436', 0, 0, myid, 6, 0 )
+                ELSE
+
+                   IF ( vegetation_pars_f%pars_xy(ind_v_rc_min,j,i) /=            &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%r_canopy_min(m)  =                               &
+                                      vegetation_pars_f%pars_xy(ind_v_rc_min,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_rc_lai,j,i) /=            &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%lai(m)           =                               &
+                                      vegetation_pars_f%pars_xy(ind_v_rc_lai,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_c_veg,j,i) /=             &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%c_veg(m)         =                               &
+                                      vegetation_pars_f%pars_xy(ind_v_c_veg,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_gd,j,i) /=                &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%g_d(m)           =                               &
+                                      vegetation_pars_f%pars_xy(ind_v_gd,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_z0,j,i) /=                &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%z0(m)            =                               &
+                                      vegetation_pars_f%pars_xy(ind_v_z0,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_z0qh,j,i) /=              &
+                        vegetation_pars_f%fill )  THEN
+                      surf_lsm_h(l)%z0h(m)           =                               &
+                                      vegetation_pars_f%pars_xy(ind_v_z0qh,j,i)
+                      surf_lsm_h(l)%z0q(m)           =                               &
+                                      vegetation_pars_f%pars_xy(ind_v_z0qh,j,i)
+                   ENDIF
+                   IF ( vegetation_pars_f%pars_xy(ind_v_lambda_s,j,i) /=          &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%lambda_surface_s(m) =                            &
+                                      vegetation_pars_f%pars_xy(ind_v_lambda_s,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_lambda_u,j,i) /=          &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%lambda_surface_u(m) =                            &
+                                      vegetation_pars_f%pars_xy(ind_v_lambda_u,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_f_sw_in,j,i) /=           &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%f_sw_in(m)          =                            &
+                                      vegetation_pars_f%pars_xy(ind_v_f_sw_in,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_c_surf,j,i) /=            &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%c_surface(m)        =                            &
+                                      vegetation_pars_f%pars_xy(ind_v_c_surf,j,i)
+                   IF ( vegetation_pars_f%pars_xy(ind_v_at,j,i) /=                &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%albedo_type(m,ind_veg_wall) =                    &
+                                      INT( vegetation_pars_f%pars_xy(ind_v_at,j,i) )
+                   IF ( vegetation_pars_f%pars_xy(ind_v_emis,j,i) /=              &
+                        vegetation_pars_f%fill )                                  &
+                      surf_lsm_h(l)%emissivity(m,ind_veg_wall)  =                    &
+                                      vegetation_pars_f%pars_xy(ind_v_emis,j,i)
                 ENDIF
-                IF ( vegetation_pars_f%pars_xy(ind_v_lambda_s,j,i) /=          &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%lambda_surface_s(m) =                            &
-                                   vegetation_pars_f%pars_xy(ind_v_lambda_s,j,i)
-                IF ( vegetation_pars_f%pars_xy(ind_v_lambda_u,j,i) /=          &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%lambda_surface_u(m) =                            &
-                                   vegetation_pars_f%pars_xy(ind_v_lambda_u,j,i)
-                IF ( vegetation_pars_f%pars_xy(ind_v_f_sw_in,j,i) /=           &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%f_sw_in(m)          =                            &
-                                   vegetation_pars_f%pars_xy(ind_v_f_sw_in,j,i)
-                IF ( vegetation_pars_f%pars_xy(ind_v_c_surf,j,i) /=            &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%c_surface(m)        =                            &
-                                   vegetation_pars_f%pars_xy(ind_v_c_surf,j,i)
-                IF ( vegetation_pars_f%pars_xy(ind_v_at,j,i) /=                &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%albedo_type(m,ind_veg_wall) =                    &
-                                   INT( vegetation_pars_f%pars_xy(ind_v_at,j,i) )
-                IF ( vegetation_pars_f%pars_xy(ind_v_emis,j,i) /=              &
-                     vegetation_pars_f%fill )                                  &
-                   surf_lsm_h%emissivity(m,ind_veg_wall)  =                    &
-                                   vegetation_pars_f%pars_xy(ind_v_emis,j,i)
-             ENDIF
+             ENDDO
           ENDDO
 !
@@ -3565,20 +3635,22 @@
 !
 !--    Map values onto horizontal elemements
-       DO  m = 1, surf_lsm_h%ns
-          IF ( surf_lsm_h%water_surface(m) )  THEN
-             IF ( TRIM( initializing_actions ) /= 'read_restart_data' )        &
-                t_soil_h%var_2d(:,m)        = water_temperature
-             surf_lsm_h%z0(m)               = z0_water
-             surf_lsm_h%z0h(m)              = z0h_water
-             surf_lsm_h%z0q(m)              = z0q_water
-             surf_lsm_h%lambda_surface_s(m) = 1.0E10_wp
-             surf_lsm_h%lambda_surface_u(m) = 1.0E10_wp
-             surf_lsm_h%c_surface(m)        = 0.0_wp
-             surf_lsm_h%albedo_type(m,ind_wat_win) = albedo_type
-             surf_lsm_h%emissivity(m,ind_wat_win)  = emissivity
-
-             surf_lsm_h%water_type(m)      = water_type
-             surf_lsm_h%water_type_name(m) = water_type_name(water_type)
-          ENDIF
+       DO  l = 0, 1
+          DO  m = 1, surf_lsm_h(l)%ns
+             IF ( surf_lsm_h(l)%water_surface(m) )  THEN
+                IF ( TRIM( initializing_actions ) /= 'read_restart_data' )        &
+                   t_soil_h(l)%var_2d(:,m)        = water_temperature
+                surf_lsm_h(l)%z0(m)               = z0_water
+                surf_lsm_h(l)%z0h(m)              = z0h_water
+                surf_lsm_h(l)%z0q(m)              = z0q_water
+                surf_lsm_h(l)%lambda_surface_s(m) = 1.0E10_wp
+                surf_lsm_h(l)%lambda_surface_u(m) = 1.0E10_wp
+                surf_lsm_h(l)%c_surface(m)        = 0.0_wp
+                surf_lsm_h(l)%albedo_type(m,ind_wat_win) = albedo_type
+                surf_lsm_h(l)%emissivity(m,ind_wat_win)  = emissivity
+
+                surf_lsm_h(l)%water_type(m)      = water_type
+                surf_lsm_h(l)%water_type_name(m) = water_type_name(water_type)
+             ENDIF
+          ENDDO
        ENDDO
 !
@@ -3589,5 +3661,5 @@
              IF ( surf_lsm_v(l)%water_surface(m) )  THEN
                 IF ( TRIM( initializing_actions ) /= 'read_restart_data' )     &
-                   t_soil_v(l)%var_2d(:,m)           = water_temperature
+                   t_soil_v(l)%var_2d(:,m)        = water_temperature
                 surf_lsm_v(l)%z0(m)               = z0_water
                 surf_lsm_v(l)%z0h(m)              = z0h_water
